'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 10 September 2002 at 1:03:13 am'!

!Object methodsFor: 'user interface' stamp: 'fg 9/10/2002 00:23'!
explore

	ObjectExplorer new openExplorerFor: self! !


!IndentingListItemMorph methodsFor: 'mouse events' stamp: 'fg 8/1/2001 00:35'!
handlesMouseOver: evt
	^ true! !

!IndentingListItemMorph methodsFor: 'mouse events' stamp: 'fg 8/1/2001 00:47'!
mouseEnter: evt
	container mouseEnter: evt onItem: self.
	self changed
	! !

!IndentingListItemMorph methodsFor: 'morphic wrappers' stamp: 'fg 8/3/2001 16:44'!
aerialTarget
	^ complexContents item asMorph! !


!ListItemWrapper methodsFor: 'as yet unclassified' stamp: 'fg 9/10/2002 00:36'!
item
	^ item! !


!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'fg 12/17/2001 16:06'!
explorerFor: anObject
	| window listMorph |
	rootObject _ anObject.
	window _ (SystemWindow labelled: 'Explorer') 
				model: self;
				paneColor: Color lightYellow darker.
	window addMorph: (listMorph _ SimpleHierarchicalListMorph 
			on: self
			list: #getList
			selected: #getCurrentSelection
			changeSelected: #noteNewSelection:
			menu: #genericMenu:
			keystroke: nil)
		frame: (0@0 corner: 1@1).
	listMorph autoDeselect: false.
     ^ window! !

!ObjectExplorer methodsFor: 'as yet unclassified' stamp: 'fg 7/14/2001 21:42'!
initialExtent

	^300@300! !


!ScrollPane methodsFor: 'access' stamp: 'fg 8/1/2001 00:56'!
highlightedIndex
	scroller submorphs withIndexDo: [:any :i | any highlightedForMouseDown ifTrue: [^ i]].
	^ 0! !


!SimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'fg 8/1/2001 00:49'!
initialize
	super initialize.
	self on: #mouseMove send: #mouseStillDown:onItem: to: self.
	self enableDragNDrop! !

!SimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'fg 8/1/2001 00:40'!
drawOn: aCanvas
	super drawOn: aCanvas.
	"
	selectedMorph ifNotNil:
		[aCanvas fillRectangle:
			(((scroller transformFrom: self) invertBoundsRect: selectedMorph bounds)
						intersect: scroller bounds)
				color: color darker]
	"! !

!SimpleHierarchicalListMorph methodsFor: 'events' stamp: 'fg 9/10/2002 00:34'!
mouseEnter: event onItem: aMorph
	self setSelectedMorph: aMorph! !

!SimpleHierarchicalListMorph methodsFor: 'model access' stamp: 'fg 9/10/2002 00:35'!
itemKeyStroke: event
	"MorphicWrapper keyStroke handling"

	| currentSelection mw balloon |
	currentSelection _ self model getCurrentSelection.
	currentSelection isNil ifTrue: [^ nil].
	mw _ currentSelection item asMorph.
	balloon _ CodeBalloonMorph for: mw hand: event hand.
	^ balloon keyStroke: event
! !

!SimpleHierarchicalListMorph methodsFor: 'model access' stamp: 'fg 7/14/2001 22:29'!
keyStroke: event 
	"Process potential command keys"
	| args aCharacter |
	(self scrollByKeyboard: event)
		ifTrue: [^ self].
	keystrokeActionSelector == nil ifTrue: [^ self itemKeyStroke: event].
	aCharacter _ event keyCharacter.
	(args _ keystrokeActionSelector numArgs) = 1 ifTrue: [^ model perform: keystrokeActionSelector with: aCharacter].
	args = 2 ifTrue: [^ model
			perform: keystrokeActionSelector
			with: aCharacter
			with: self].
	^ self error: 'The keystrokeActionSelector must be a 1- or 2-keyword symbol'! !

!SimpleHierarchicalListMorph methodsFor: 'dropping/grabbing' stamp: 'fg 8/1/2001 01:12'!
startDrag: evt
	| ddm itemMorph itemModel index |
	self dragEnabled 
		ifTrue:
			[index _ self highlightedIndex.
			index > 0 
				ifTrue: 
					[itemMorph _ scroller submorphs at: index.
					itemModel _ itemMorph complexContents item]].
	(itemMorph isNil or:[evt hand hasSubmorphs]) ifTrue: [^self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph ifTrue: [self setSelectedMorph: itemMorph].
	ddm _ TransferMorph withPassenger: (self model dragPassengerFor: itemModel inMorph: self) from: self.
	ddm dragTransferType: (self model dragTransferTypeForMorph: self).
	Preferences dragNDropWithAnimation
			ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
	evt hand grabMorph: ddm.
	evt hand releaseMouseFocus: self.! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

Preferences enable: #exploreComplexMorphicWrappers

!

